<template>
  <section class="container">
    <h2>{{ user.name }}</h2>
    <h3>{{ user.age }}</h3>
    <button @click="setAge">Change age</button>
    <h2>{{ userName }}</h2>
    <div>
      <input type="text" placeholder="First Name" @input="setFirstName"/>
      <input type="text" placeholder="Last Name" @input="setLastName"/>
    </div>
  </section>
</template>

<script>
import { reactive, ref, computed } from 'vue';

export default {
  setup() {
    const user = reactive({
      name: 'Maximilian',
      age: 30,
    });
    const firstName = ref('');
    const lastName = ref('');

    // computed properties are read only
    const userName = computed(function() {
      return firstName.value + ' ' + lastName.value;
    });

    function setNewAge() {
      user.age = 32;
    }

    function setFirstName(event) {
      firstName.value = event.target.value;
    }

    function setLastName(event) {
      lastName.value = event.target.value;
    }

    return {
      user,
      setAge: setNewAge,
      setFirstName,
      setLastName,
      userName
    };
  },
};
</script>

<style>
* {
  box-sizing: border-box;
}

html {
  font-family: sans-serif;
}

body {
  margin: 0;
}

.container {
  margin: 3rem auto;
  max-width: 30rem;
  border-radius: 12px;
  box-shadow: 0 2px 8px rgba(0, 0, 0, 0.26);
  padding: 1rem;
  text-align: center;
}
</style>
